package com.yunzhupaas.service.impl;

import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.yunzhupaas.base.service.BillRuleService;
import com.yunzhupaas.base.service.SuperServiceImpl;
import com.yunzhupaas.entity.LeaveApplyEntity;
import com.yunzhupaas.mapper.LeaveApplyMapper;
import com.yunzhupaas.model.leaveapply.LeaveApplyForm;
import com.yunzhupaas.service.LeaveApplyService;
import com.yunzhupaas.util.JsonUtil;
import com.yunzhupaas.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 流程表单【请假申请】
 *
 * @author 云筑产品开发平台组
 * @version V3.1.0
 * @copyright 深圳市乐程软件有限公司
 * @date 2024-09-29 上午9:18
 */
@Service
public class LeaveApplyServiceImpl extends SuperServiceImpl<LeaveApplyMapper, LeaveApplyEntity> implements LeaveApplyService {

    @Autowired
    private BillRuleService billRuleService;

    @Override
    public LeaveApplyEntity getInfo(String id) {
        QueryWrapper<LeaveApplyEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(LeaveApplyEntity::getId, id);
        return getOne(queryWrapper);
    }

    @Override
    @DSTransactional
    public void save(String id, LeaveApplyEntity entity, LeaveApplyForm form) {
        //表单信息
        if (StringUtil.isEmpty(entity.getId())) {
            entity.setId(id);
            save(entity);
            billRuleService.useBillNumber("WF_LeaveApplyNo");
        } else {
            entity.setId(id);
            updateById(entity);
        }
    }

    @Override
    @DSTransactional
    public void submit(String id, LeaveApplyEntity entity, LeaveApplyForm form) {
        //表单信息
        if (StringUtil.isEmpty(entity.getId())) {
            entity.setId(id);
            save(entity);
            billRuleService.useBillNumber("WF_LeaveApplyNo");
        } else {
            entity.setId(id);
            updateById(entity);
        }
    }

    @Override
    public void data(String id, String data) {
        LeaveApplyForm leaveApplyForm = JsonUtil.getJsonToBean(data, LeaveApplyForm.class);
        LeaveApplyEntity entity = JsonUtil.getJsonToBean(leaveApplyForm, LeaveApplyEntity.class);
        entity.setId(id);
        saveOrUpdate(entity);
    }

    @Override
    public void delete(LeaveApplyEntity entity) {
        this.removeById(entity);
    }

}

